import 'package:flutter/material.dart';
import 'package:shared_package_flutter/list_view/list_view_error.dart';

class ListViewParams<T>{
  final int _itemCount;
  final Function( BuildContext, int ) _itemBuilder;

  ListViewParams(
    this._itemCount,
    this._itemBuilder
  );
}

class ListViewComponent<T> extends StatelessWidget {
  final ListViewParams<T> _params;

  ListViewComponent( this._params, { Key key } ): super( key: key );

  Widget show( ){

    return ListView.separated(
      physics: AlwaysScrollableScrollPhysics( ),
      itemCount: this._params._itemCount,
      itemBuilder: ( context, index ){
        return this._params._itemBuilder( context, index );
      },
      separatorBuilder: ( context, index ){
        return Divider( thickness: 3 );
      },
    );
  }

  @override
  Widget build( BuildContext context ){

    return null != this._params && this._params._itemCount > 0
      ? show( )
      : ListViewError.show( context, "Sem registros" );
  }
}